Bug 497593

Summary: Review Request: gnome-alsamixer - advanced mixer for GNOME
Product: [Fedora] Fedora Reporter: Adam Williamson <awilliam>
Component: Package ReviewAssignee: Andreas Thienemann <andreas>
Status: CLOSED NOTABUG QA Contact: Fedora Extras Quality Assurance <extras-qa>
Severity: medium Docs Contact:
Priority: medium    
Version: rawhideCC: andreas, cwickert, dan, fedora-package-review, itamar, jlaska, julian.fedora, leigh123linux, notting, pahan, sundaram
Target Milestone: ---   
Target Release: ---   
Hardware: All   
OS: Linux   
Whiteboard:
Fixed In Version: Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of: Environment:
Last Closed: 2011-01-07 10:50:14 EST Type: ---
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Bug Depends On:    
Bug Blocks: 201449    
Attachments:
Description Flags
Patch fixing minor issues in the .spec (e.g. desktop-file-install etc.) and a bit of whitespacing
none
thanks for providing a decent alternative to PA
none
changing inline .desktop to external
none
successfull build log of alsamixer-0.9.7-0.1.20090424gitc540b26.fc10.src.rpm (with one small change in the spec) none

Description Adam Williamson 2009-04-24 17:40:26 EDT
Spec URL: http://adamwill.fedorapeople.org/gnome-alsamixer/gnome-alsamixer.spec
SRPM URL: http://adamwill.fedorapeople.org/gnome-alsamixer/gnome-alsamixer-0.9.7-0.1.20090424aw_fc11.src.rpm
Description: A full control ALSA mixer application for GNOME. Per FESco meeting of April 24th 2009, for Fedora 11 release.

(Exists in CVS already from FC2 era, this is a fresh spec based on the Mandriva spec, since I worked on that one a while back.)
Comment 1 Andreas Thienemann 2009-04-24 17:41:44 EDT
reviewing...
Comment 2 Adam Williamson 2009-04-24 18:08:12 EDT
spec revised to fix a few errors and mandriva-isms and pass rpmlint and mock build, same URLs.

-- 
Fedora Bugzappers volunteer triage team
https://fedoraproject.org/wiki/BugZappers
Comment 3 Adam Williamson 2009-04-24 18:44:37 EDT
revised a bit more per comments from ixs, and srpm location changed slightly:

http://adamwill.fedorapeople.org/gnome-alsamixer/gnome-alsamixer-0.9.7-0.1.20090424.aw_fc11.src.rpm

-- 
Fedora Bugzappers volunteer triage team
https://fedoraproject.org/wiki/BugZappers
Comment 5 Andreas Thienemann 2009-04-24 19:41:58 EDT
Created attachment 341259 [details]
Patch fixing minor issues in the .spec (e.g. desktop-file-install etc.) and a bit of whitespacing
Comment 6 Andreas Thienemann 2009-04-24 20:10:44 EDT
Mandatory items
===============

[ PASS ] MUST: rpmlint must be run on every package.
   rpmlint /var/lib/mock/fedora-rawhide-i386/result/*.rpm
   gnome-alsamixer.i586: W: non-conffile-in-etc /etc/gconf/schemas/gnome-alsamixer.schemas
   3 packages and 0 specfiles checked; 0 errors, 1 warnings.
   Warning is to be ignored
[ OKAY ] MUST: The package must be named according to the Package Naming Guidelines.
[ OKAY ] MUST: The spec file name must match the base package %{name}, in the format %{name}.spec unless your package has an exemption.
[ OKAY ] MUST: The package must meet the Packaging Guidelines .
[ OKAY ] MUST: The package must be licensed with a Fedora approved license and meet the Licensing Guidelines.
[ OKAY ] MUST: The License field in the package spec file must match the actual license.
[ OKAY ] MUST: If (and only if) the source package includes the text of the license(s) in its own file, then that file, containing the text of the license(s) for the package must be included in %doc.
[ OKAY ] MUST: The spec file must be written in American English.
[ OKAY ] MUST: The spec file for the package MUST be legible.
[ TODO ] MUST: The sources used to build the package must match the upstream source, as provided in the spec URL.
   671ac31745fe4a8d4c40c18f6a5fd1aa  gnome-alsamixer-20090424gitc540b26.tar.bz2
   This has been verified to correspond to git sha1 c540b26. Please include specifics on generating the tarball. See https://fedoraproject.org/wiki/Packaging/SourceURL#Using_Revision_Control
[ OKAY ] MUST: The package MUST successfully compile and build into binary rpms on at least one primary architecture.
   Build successfully on i586, ppc, ppc64 and x86_64
[ NOOP ] MUST: If the package does not successfully compile, build or work on an architecture, then those architectures should be listed in the spec in ExcludeArch. Each architecture listed in ExcludeArch MUST have a bug filed in bugzilla, describing the reason that the package does not compile/build/work on that architecture. The bug number MUST be placed in a comment, next to the corresponding ExcludeArch line.
[ OKAY ] MUST: All build dependencies must be listed in BuildRequires, except for any that are listed in the exceptions section of the Packaging Guidelines ; inclusion of those as BuildRequires is optional.
[ OKAY ] MUST: The spec file MUST handle locales properly.
[ NOOP ] MUST: Every binary RPM package (or subpackage) which stores shared library files (not just symlinks) in any of the dynamic linker's default paths, must call ldconfig in %post and %postun.
[ NOOP ] MUST: If the package is designed to be relocatable, the packager must state this fact in the request for review, along with the rationalization for relocation of that specific package. Without this, use of Prefix: /usr is considered a blocker.
[ OKAY ] MUST: A package must own all directories that it creates. If it does not create a directory that it uses, then it should require a package which does create that directory.
[ OKAY ] MUST: A Fedora package must not list a file more than once in the spec file's %files listings.
[ OKAY ] MUST: Permissions on files must be set properly. Executables should be set with executable permissions, for example. Every %files section must include a %defattr(...) line.
[ OKAY ] MUST: Each package must have a %clean section, which contains rm -rf %{buildroot} (or $RPM_BUILD_ROOT).
[ OKAY ] MUST: Each package must consistently use macros.
[ OKAY ] MUST: The package must contain code, or permissable content.
[ NOOP ] MUST: Large documentation files must go in a -doc subpackage.
[ NOOP ] MUST: If a package includes something as %doc, it must not affect the runtime of the application.
[ NOOP ] MUST: Header files must be in a -devel package.
[ NOOP ] MUST: Static libraries must be in a -static package.
[ NOOP ] MUST: Packages containing pkgconfig(.pc) files must 'Requires: pkgconfig' (for directory ownership and usability).
[ NOOP ] MUST: If a package contains library files with a suffix (e.g. libfoo.so.1.1), then library files that end in .so (without suffix) must go in a -devel package.
[ NOOP ] MUST: In the vast majority of cases, devel packages must require the base package using a fully versioned dependency.
[ OKAY ] MUST: Packages must NOT contain any .la libtool archives, these must be removed in the spec if they are built.
[ TODO ] MUST: Packages containing GUI applications must include a %{name}.desktop file, and that file must be properly installed with desktop-file-install in the %install section.
   desktop-file-install is not used.
[ OKAY ] MUST: Packages must not own files or directories already owned by other packages.
[ OKAY ] MUST: At the beginning of %install, each package MUST run rm -rf %{buildroot} (or $RPM_BUILD_ROOT).
[ OKAY ] MUST: All filenames in rpm packages must be valid UTF-8.


Optional items
==============

[ NOOP ] SHOULD: If the source package does not include license text(s) as a separate file from upstream, the packager SHOULD query upstream to include it.
[ PASS ] SHOULD: The description and summary sections in the package spec file should contain translations for supported Non-English languages, if available.
[ OKAY ] SHOULD: The reviewer should test that the package builds in mock.
[ OKAY ] SHOULD: The package should compile and build into binary rpms on all supported architectures.
[ OKAY ] SHOULD: The reviewer should test that the package functions as described.
[ TODO ] SHOULD: If scriptlets are used, those scriptlets must be sane.
[ NOOP ] SHOULD: Usually, subpackages other than devel should require the base package using a fully versioned dependency.
[ NOOP ] SHOULD: The placement of pkgconfig(.pc) files depends on their usecase, and this is usually for development purposes, so should be placed in a -devel pkg. A reasonable exception is that the main pkg itself is a devel tool not installed in a user runtime, e.g. gcc or gdb.
[ NOOP ] SHOULD: If the package has file dependencies outside of /etc, /bin, /sbin, /usr/bin, or /usr/sbin consider requiring the package which provides the file instead of the file itself.

Notes
=====

Package is mostly fine. See the attached patch, it fixes some minor issues such as the missing desktop-file-install usage and the correct source URL.
Please apply.

ToDo List
=========
   * Describe the processs of generating the tarball (e.g. rm -rf .git)
   * Use desktop-file-install (in patch)
   * Add error handler to %post handler (in patch)
Comment 7 Rahul Sundaram 2009-04-25 00:56:13 EDT
Is there a reason you are picking this project which is dead upstream instead of using the one included in Fedora 10 which is part of gnome-media?
Comment 8 Adam Williamson 2009-04-25 02:15:19 EDT
Rahul: my reasoning is that the one from gnome-media in f10 is the one that's truly 'dead', because it's been turning into the new Pulse-style mixer that this is intended to supplement. I think it'd be more of a hack to take the old g-v-c from f10 era and call it something else than it is to just take a different project.

what we're demonstrating here is that there's likely to be space for a 'full' mixer for GNOME for the foreseeable future, so to me it seems to make more sense to pick gnome-alsamixer, which - if the demand turns out to be there - could easily be resurrected as a fully maintained project upstream; the space is there for it and it's still a part of GNOME git. You couldn't do that with the old gnome-volume-control, because that's already become the *new* gnome-volume-control...

I wouldn't really mind if people felt strongly that we should take the old g-v-c instead, though. my goal is only to have a decent GUI alsa-level mixer available out of the box in f11, I'm not that strongly wedded to one or the other.
Comment 9 Rahul Sundaram 2009-04-25 02:33:10 EDT
IMO, your understanding seems incorrect. Refer

http://mail.gnome.org/archives/desktop-devel-list/2009-January/msg00330.html
Comment 10 Adam Williamson 2009-04-25 03:59:01 EDT
Quoting Dave Airlie from the list:

"I took a quick look at this, and gnome-media has the code moved to the
gst-mixer subdir, but thats it, the code still believes its called
g-v-c, all the files are called that, the gconf schema keys, the
desktop, etc.

So I suspect the effort to do that vs ship gnome-alsamixer at this point
in the development cycle isn't going to provide any useful advantages to
the advanced sound configuration people are requiring. Like it the
answer to the question is otherwise run a cli app called alsamixer, I'd
ship a kde app quicker :)"

To this I'd add that we don't necessarily *want* a fairly heavy gstreamer mixer applet that supports Pulse as well as ALSA mixer control. We want a simple standalone application that simply lets you poke the ALSA mixers, nothing else. gnome-alsamixer seems to fit that description.

But again I will go for the old g-v-c if more people favour it. I'd just ask that someone else do the work of completing the re-write to identify as something different from the new g-v-c, and handling the package, as I'm not familiar with it at all.
Comment 11 Adam Williamson 2009-04-25 04:05:19 EDT
Just uploaded an updated .spec and .src.rpm with the patch applied.
Comment 12 Andreas Thienemann 2009-04-25 04:16:03 EDT
Looks good. Approved.

Please be so kind and add all commands needed for tarball generation as a comment. Not only git clone, but the appropriate tar command. But we don't need a new review-round for that.

Please follow http://fedoraproject.org/wiki/CVS_admin_requests to have the existing gnome-alsamixer ACLs changed and a new branch created for F11 and devel. A "Package Change Request" would be appropriate for that.
Comment 13 manuel wolfshant 2009-04-25 05:33:16 EDT
Created attachment 341305 [details]
thanks for providing a decent alternative to PA

Thanks for bringing this tool in, guys. Despite what PA team thinks, I prefer the topmost control panel over the one in the bottom. With alsa I can individually control the left and right output channel. And a couple more inputs which are doomed in PA as being irrelevant.
Comment 14 Christoph Wickert 2009-04-25 06:50:15 EDT
Please don't use %makeinstall, see
https://fedoraproject.org/wiki/Packaging/Guidelines#Why_the_.25makeinstall_macro_should_not_be_used

Inline desktop file creation ws forbidden recently, see
https://fedoraproject.org/wiki/Packaging/Guidelines#.desktop_file_creation

rpmbuild --rebuild does not work for F-10, see http://fpaste.org/paste/10125
Comment 15 Dan Horák 2009-04-25 07:52:56 EDT
(In reply to comment #14)
> Inline desktop file creation ws forbidden recently, see
> https://fedoraproject.org/wiki/Packaging/Guidelines#.desktop_file_creation

The guidelines were not updated yet, but inline creating of desktop files is allowed for few weeks now, see https://fedorahosted.org/fesco/ticket/129 for details.
Comment 16 Andreas Thienemann 2009-04-25 08:02:04 EDT
(In reply to comment #14)


> Please don't use %makeinstall, see
> https://fedoraproject.org/wiki/Packaging/Guidelines#Why_the_.25makeinstall_macro_should_not_be_used

As discussed on IRC: make DESTDIR doesn't work, I checked.
Patching the makefile would be an option, but using %makeinstall does work as expected. If the maintainer wants to patch the Makefile to make DESTDIR work, that is fine. I'd leave it to his discretion.
It's not a blocker as is.

> Inline desktop file creation ws forbidden recently, see
> https://fedoraproject.org/wiki/Packaging/Guidelines#.desktop_file_creation

The wiki does state "You can do this by including a .desktop file you create as a Source: (e.g. Source3: %{name}.desktop) or generating it in the spec file."

As you mentioned on IRC, there seems to have been a mail somewhere stating this. So even though it seems not (yet) to be official policy, I've attached a patch fixing this potential future problem. 

> rpmbuild --rebuild does not work for F-10, see http://fpaste.org/paste/10125  

Old file. That was already fixed. http://adamwill.fedorapeople.org/gnome-alsamixer/gnome-alsamixer-0.9.7-0.1.20090424gitc540b26.fc10.src.rpm was the last submission from packager and does not exhibit that problem.
Not a blocker.
Comment 17 Andreas Thienemann 2009-04-25 08:04:31 EDT
Created attachment 341313 [details]
changing inline .desktop to external
Comment 18 Andreas Thienemann 2009-04-25 08:07:11 EDT
(In reply to comment #15)

> The guidelines were not updated yet, but inline creating of desktop files is
> allowed for few weeks now, see https://fedorahosted.org/fesco/ticket/129 for
> details.  

Thanks for clearing that up.

Considering that, I'd retract my latest patch. Package is fine as is. If Adam wants to externalize the .desktop file, it's up to him. I don't consider any of the raised points blockers for inclusion.
Comment 19 manuel wolfshant 2009-04-25 08:18:33 EDT
(In reply to comment #16)

> > rpmbuild --rebuild does not work for F-10, see http://fpaste.org/paste/10125  
> 
> Old file. That was already fixed.
> http://adamwill.fedorapeople.org/gnome-alsamixer/gnome-alsamixer-0.9.7-0.1.20090424gitc540b26.fc10.src.rpm


at least in a mockbuild for F10 the construct
   cat > /%{name}.desktop << EOF
fails because / is not writable by mock.
   cat > %{name}.desktop << EOF
however works just fine.
Comment 20 Christoph Wickert 2009-04-25 08:27:00 EDT
(In reply to comment #16)
> Old file. That was already fixed.
> http://adamwill.fedorapeople.org/gnome-alsamixer/gnome-alsamixer-0.9.7-0.1.20090424gitc540b26.fc10.src.rpm
> was the last submission from packager and does not exhibit that problem.
> Not a blocker. 

This *is* the latest submission and it fails:

$ rpmbuild --rebuild Desktop/gnome-alsamixer-0.9.7-0.1.20090424gitc540b26.fc10.src.rpm 
Installiere Desktop/gnome-alsamixer-0.9.7-0.1.20090424gitc540b26.fc10.src.rpm
Warnung: Benutzer adamw existiert nicht - benutze Root
Warnung: Gruppe adamw existiert nicht - benutze Root
Warnung: Benutzer adamw existiert nicht - benutze Root
Warnung: Gruppe adamw existiert nicht - benutze Root
Warnung: Benutzer adamw existiert nicht - benutze Root
Warnung: Gruppe adamw existiert nicht - benutze Root
Warnung: Benutzer adamw existiert nicht - benutze Root
Warnung: Gruppe adamw existiert nicht - benutze Root
Warnung: Benutzer adamw existiert nicht - benutze Root
Warnung: Gruppe adamw existiert nicht - benutze Root
Warnung: Benutzer adamw existiert nicht - benutze Root
Warnung: Gruppe adamw existiert nicht - benutze Root
Warnung: Benutzer adamw existiert nicht - benutze Root
Warnung: Gruppe adamw existiert nicht - benutze Root
Warnung: Benutzer adamw existiert nicht - benutze Root
Warnung: Gruppe adamw existiert nicht - benutze Root
Fehler: Zeile 24: Ungültiges Zeichen '-' in release: Release:	0.1.20090424gitc540b26.gnome-alsamixer-20090424gitc540b26.tar.bz210
Comment 21 manuel wolfshant 2009-04-25 08:33:34 EDT
Created attachment 341315 [details]
successfull build log of alsamixer-0.9.7-0.1.20090424gitc540b26.fc10.src.rpm (with one small change in the spec)

only change versus http://adamwill.fedorapeople.org/gnome-alsamixer/gnome-alsamixer-0.9.7-0.1.20090424gitc540b26.fc10.src.rpm is removing the leading "/" in the name of the desktop file when creating it inline.
Comment 22 Andreas Thienemann 2009-04-25 08:38:56 EDT
(In reply to comment #20)

> This *is* the latest submission and it fails

Works for me:

[andreas@workstation ~]$ wget -q http://adamwill.fedorapeople.org/gnome-alsamixer/gnome-alsamixer-0.9.7-0.1.20090424gitc540b26.fc10.src.rpm
[andreas@workstation ~]$ rpmbuild --rebuild gnome-alsamixer-0.9.7-0.1.20090424gitc540b26.fc10.src.rpm
Installing gnome-alsamixer-0.9.7-0.1.20090424gitc540b26.fc10.src.rpm
warning: user adamw does not exist - using root
warning: group adamw does not exist - using root
warning: user adamw does not exist - using root
warning: group adamw does not exist - using root
warning: user adamw does not exist - using root
warning: group adamw does not exist - using root
warning: user adamw does not exist - using root
warning: group adamw does not exist - using root
warning: user adamw does not exist - using root
warning: group adamw does not exist - using root
warning: user adamw does not exist - using root
warning: group adamw does not exist - using root
warning: user adamw does not exist - using root
warning: group adamw does not exist - using root
warning: user adamw does not exist - using root
warning: group adamw does not exist - using root
Executing(%prep): /bin/sh -e /var/tmp/rpm-tmp.EDaoPb
Comment 23 Andreas Thienemann 2009-04-25 08:41:24 EDT
(In reply to comment #19)

> at least in a mockbuild for F10 the construct
>    cat > /%{name}.desktop << EOF
> fails because / is not writable by mock.
>    cat > %{name}.desktop << EOF
> however works just fine.  

good catch. My fault in the patch when I changed to desktop-file-install which I "corrected" when I switched to the external .desktop file so I never noticed that part during the review...

Should be fixed for the import.
Comment 24 Adam Williamson 2009-04-28 16:48:50 EDT
just an update here: I am currently not working on this, as I'm trying to build a package of the old gnome-volume-control code instead to make Bastien happy. He would rather have the old gnome-volume-control (which is still maintained for use in non-Pulse situations like Solaris) rather than the effectively unmaintained gnome-alsamixer.

I'm trying to get a fully working old gnome-volume-control, parallel installable with the new one, built by the end of today - it has to be patched to identify itself as something other than gnome-volume-control, but Ubuntu has some patches to do that which I should be able to steal.

-- 
Fedora Bugzappers volunteer triage team
https://fedoraproject.org/wiki/BugZappers
Comment 25 Adam Williamson 2009-04-28 22:28:42 EDT
here's the review request for gst-mixer:

https://bugzilla.redhat.com/show_bug.cgi?id=498136

I'd rather focus on that for now, after that we can decide if it's a good idea to put gnome-alsamixer in too or not.

-- 
Fedora Bugzappers volunteer triage team
https://fedoraproject.org/wiki/BugZappers
Comment 26 James Laska 2009-05-06 10:00:10 EDT
Should this bug remain open?
Comment 27 Adam Williamson 2009-05-06 12:15:21 EDT
I'd tend towards 'no'.
Comment 28 Julian Aloofi 2011-01-07 10:10:57 EST
Should probably be closed now?
Comment 29 Christoph Wickert 2011-01-07 10:50:14 EST
Done.